# TODO
# - optflags
# - move qt stuff to subpackages?
#
# Conditional build:
%bcond_with	examples	# demo+examples build
%bcond_with	qt3		# CGAL_Qt3 library

%define	boost_ver	1.48
%define	qt5_ver		5.3
Summary:	Computational Geometry Algorithms Library
Summary(pl.UTF-8):	Computational Geometry Algorithms Library - biblioteka algorytmów geometrii obliczeniowej
Name:		CGAL
Version:	4.7
Release:	7
License:	GPL v3+ and LGPL v3+
Group:		Libraries
Source0:	https://github.com/CGAL/releases/archive/%{name}-%{version}.tar.gz
# Source0-md5:	50b29d3f3372cd93aaa31d01f0e45036
URL:		http://www.cgal.org/
BuildRequires:	OpenGL-GLU-devel
BuildRequires:	Qt5Core-devel >= %{qt5_ver}
BuildRequires:	Qt5Gui-devel >= %{qt5_ver}
BuildRequires:	Qt5OpenGL-devel >= %{qt5_ver}
BuildRequires:	Qt5Svg-devel >= %{qt5_ver}
BuildRequires:	Qt5Widgets-devel >= %{qt5_ver}
BuildRequires:	boost-devel >= %{boost_ver}
BuildRequires:	cmake >= 2.8.11
BuildRequires:	gmp-devel >= 4.1.4
BuildRequires:	libstdc++-devel
BuildRequires:	mpfr-devel >= 2.2.1
BuildRequires:	qt5-build >= %{qt5_ver}
BuildRequires:	qt5-qmake >= %{qt5_ver}
BuildRequires:	sed >= 4.0
BuildRequires:	zlib-devel
%if %{with qt3}
BuildRequires:	qt-devel >= 3
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXext-devel
%endif
%if %{with examples}
BuildRequires:	blas-devel
BuildRequires:	eigen3 >= 3.1.91
BuildRequires:	gmp-c++-devel >= 4.1.4
BuildRequires:	lapack-devel
BuildRequires:	tbb
#TODO: mpfi QGLViewer ipelib 
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Libraries for CGAL applications. CGAL is a collaborative effort of
several sites in Europe and Israel. The goal is to make the most
important of the solutions and methods developed in computational
geometry available to users in industry and academia in a C++ library.
The goal is to provide easy access to useful, reliable geometric
algorithms.

%description -l pl.UTF-8
Biblioteka dla aplikacji CGAL (Computational Geometry Algorithms
Library). CGAL to wspólny projekt kilku placówek w Europie i Izraelu.
Celem jest udostępnienie najważniejszych rozwiązań i metod powstałych
w geometrii obliczeniowej dla użytkowników przemysłowych i naukowych w
postaci biblioteki C++. Ma ona za zadanie zapewniać łatwy dostęp do
przydatnych, wiarygodnych algorytmów geometrycznych.

%package devel
Summary:	Development files and tools for CGAL applications
Summary(pl.UTF-8):	Pliki i narzędzia programistyczne dla aplikacji CGAL
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	boost-devel >= %{boost_ver}
Requires:	libstdc++-devel
# for Qt5 component
Requires:	Qt5Core-devel >= %{qt5_ver}
Requires:	Qt5Gui-devel >= %{qt5_ver}
Requires:	Qt5OpenGL-devel >= %{qt5_ver}
Requires:	Qt5Widgets-devel >= %{qt5_ver}
# for Qt3 component
%if %{with qt3}
Requires:	qt-devel >= 3
%endif
# CGAL header interfaces for (using their headers) - use Suggests?
Requires:	gmp-c++-devel >= 4.1.4
Requires:	gmp-devel >= 4.1.4
Requires:	mpfr-devel >= 2.2.1
#Suggests: eigen3 >= 3.1 gsl-devel tbb-devel vtk-devel
#Suggests(TODO): <rs_exports.h> <rs3_fncts.h> <taucs.h> <OpenMesh/Core/Mesh/PolyMesh_ArrayKernelT.hh> <NTL/ZZX.h> <mpfi.h> <LEDA/*.h> <ipelib.h>
Requires:	zlib-devel
# CGAL header interfaces for (without using their headers) - use Suggests?
Requires:	blas-devel
Requires:	lapack-devel

%description devel
This package provides the header files and tools you may need to
develop applications using CGAL.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe i narzędzia potrzebne do tworzenia
aplikacji wykorzystujących CGAL.

%package demos-source
Summary:	Examples and demos of CGAL algorithms
Summary(pl.UTF-8):	Przykłady i programy demonstracyjne do algorytmów CGAL
Group:		Documentation
Requires:	%{name}-devel = %{version}-%{release}

%description demos-source
This package provides the sources of examples and demos of CGAL
algorithms.

%description demos-source -l pl.UTF-8
Ten pakiet zawiera kod źrodłowy programów przykładowych i
demonstracyjnych do algorytmów CGAL.

%prep
%setup -q -n releases-%{name}-%{version}

%build
install -d build
cd build
# override build type, because:
# PLD is not a valid build type: only Release or Debug is allowed
%cmake .. \
	-DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \
	-DCMAKE_CXX_FLAGS_Release="%{rpmcxxflags}" \
	-DCMAKE_EXE_LINKER_FLAGS_Release="%{rpmldflags}" \
	-DCMAKE_SHARED_LINKER_FLAGS_Release="%{rpmldflags}" \
	-DCGAL_INSTALL_LIB_DIR=%{_lib} \
	-DCGAL_INSTALL_DOC_DIR= \
	%{?with_qt3:-DWITH_CGAL_Qt3=ON} \
%if %{with examples}
	-DWITH_demos=ON \
	-DWITH_examples=ON
%endif

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

# useless in binary package
%{__rm} $RPM_BUILD_ROOT%{_bindir}/{cgal_create_CMakeLists,cgal_create_cmake_script,cgal_make_macosx_app}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS CHANGES LICENSE LICENSE.BSL LICENSE.FREE_USE LICENSE.LGPL
%attr(755,root,root) %{_libdir}/libCGAL.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libCGAL.so.11
%attr(755,root,root) %{_libdir}/libCGAL_Core.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libCGAL_Core.so.11
%attr(755,root,root) %{_libdir}/libCGAL_ImageIO.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libCGAL_ImageIO.so.11
%if %{with qt3}
%attr(755,root,root) %{_libdir}/libCGAL_Qt3.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libCGAL_Qt3.so.11
%endif
%attr(755,root,root) %{_libdir}/libCGAL_Qt5.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libCGAL_Qt5.so.11

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libCGAL.so
%attr(755,root,root) %{_libdir}/libCGAL_Core.so
%attr(755,root,root) %{_libdir}/libCGAL_ImageIO.so
%if %{with qt3}
%attr(755,root,root) %{_libdir}/libCGAL_Qt3.so
%endif
%attr(755,root,root) %{_libdir}/libCGAL_Qt5.so
%{_includedir}/CGAL
%{_libdir}/CGAL
%{_mandir}/man1/cgal_create_cmake_script.1*
%changelog
* Sat Aug 01 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/CGAL.git;a=log;h=master

* Sat Aug 01 2020 Jakub Bogusz <qboosh@pld-linux.org> ec63b17
- release 7 (boost 1.73)

* Tue Oct 08 2019 Jan Rękorajski <baggins@pld-linux.org> 243ab47
- rebuild with boost 1.71
- release 6 (by relup.sh)

* Sun Apr 14 2019 Jan Rękorajski <baggins@pld-linux.org> a5143c3
- icu/boost rebuild
- release 5 (by relup.sh)

* Sat Jul 28 2018 Jan Rękorajski <baggins@pld-linux.org> a6f4d9f
- release 4 (by relup.sh)

* Sun Apr 09 2017 Jan Rękorajski <baggins@pld-linux.org> de554a1
- rebuild with boost 1.63.0
- release 3 (by relup.sh)

* Tue May 17 2016 Jan Rękorajski <baggins@pld-linux.org> f1d6851
- release 2 (by relup.sh)

* Thu Mar 24 2016 Jakub Bogusz <qboosh@pld-linux.org> 81af62e
- partial cleanup

* Wed Mar 23 2016 Jakub Bogusz <qboosh@pld-linux.org> e82f90c
- pl

* Sun Nov 15 2015 Jan Rękorajski <baggins@pld-linux.org> 9acf288
- up to 4.7

* Sun Jun 07 2015 Elan Ruusamäe <glen@delfi.ee> 98a6180
- boost rebuild
- release 2 (by relup.sh)

* Thu Apr 30 2015 Elan Ruusamäe <glen@delfi.ee> 6539928
- qt split?

* Thu Apr 30 2015 Elan Ruusamäe <glen@delfi.ee> ab30c91
- update BR, why qt3?

* Thu Apr 30 2015 Elan Ruusamäe <glen@delfi.ee> f7efb94
- leave comment why CMAKE_BUILD_TYPE override is neccessary

* Thu Apr 30 2015 Elan Ruusamäe <glen@delfi.ee> fcd3e9d
- cleanup cmake macro, drop bogus dep

* Thu Apr 30 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> b2d9afe
- up to 4.6

* Thu Apr 30 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 8db60ca
- rel 1

* Tue Jan 13 2009 Elan Ruusamäe <glen@pld-linux.org> 23c6379
- unify adapter cosmetics

* Tue Jan 13 2009 djurban <djurban@pld-linux.org> d4e9703
- from fc9, CGAL is one hell of a painful lib to package
- Wrote: /home/users/niedakh/rpm/RPMS/CGAL-3.3.1-0.99.x86_64.rpm
- looks ok, only thing missing is polish descs (still no pl keybd), will bump to rel. 1 later if it works

* Tue Jan 13 2009 djurban <djurban@pld-linux.org> 7c1d95b
- proper naming, from fc9

* Tue Jan 13 2009 djurban <djurban@pld-linux.org> 239acba
- from fc9

